| # Gaudi Framework, version v20r4
Generated: 8 Jan 2009

# IAuditor Class Reference

`#include <GaudiKernel/IAuditor.h>`

Inheritance diagram for IAuditor:

[legend]
Collaboration diagram for IAuditor:

[legend]

List of all members.

## Detailed Description

The IAuditor is the interface implmented by the AlgAuditor base class.

Concrete auditors, derived from the AlgAuditor base class are controlled via this interface.

Author:
  Marjorie Shapiro, LBNL

  Marco Clemencic <marco.clemencic@cern.ch>

Definition at line 21 of file IAuditor.h.

## Public Types
enum | StandardEventType { Initialize, ReInitialize, Execute, BeginRun, EndRun, Finalize, Start, Stop, ReStart }
| Defines the standard (= used by the framework) auditable event types. More...
typedef std::string | CustomEventType
| Type used to allow users to specify a custom event to be audit.
typedef const CustomEventType & | CustomEventTypeRef
| Used in function calls for optimization purposes.
## Public Member Functions
virtual void | before (StandardEventType, INamedInterface *)=0
| Audit the start of a standard "event".
virtual void | before (StandardEventType, const std::string &)=0
| Audit the start of a standard "event" for callers that do not implement INamedInterface.
virtual void | before (CustomEventTypeRef, INamedInterface *)=0
| Audit the start of a custom "event".
virtual void | before (CustomEventTypeRef, const std::string &)=0
| Audit the start of a custom "event" for callers that do not implement INamedInterface.
virtual void | after (StandardEventType, INamedInterface *, const StatusCode &sc=StatusCode(StatusCode::SUCCESS, true))=0
| Audit the end of a standard "event".
virtual void | after (StandardEventType, const std::string &, const StatusCode &sc=StatusCode(StatusCode::SUCCESS, true))=0
| Audit the end of a standard "event" for callers that do not implement INamedInterface.
virtual void | after (CustomEventTypeRef, INamedInterface *, const StatusCode &sc=StatusCode(StatusCode::SUCCESS, true))=0
| Audit the end of a custom "event".
virtual void | after (CustomEventTypeRef, const std::string &, const StatusCode &sc=StatusCode(StatusCode::SUCCESS, true))=0
| Audit the end of a custom "event" for callers that do not implement INamedInterface.
virtual bool | isEnabled () const =0
| Tell if the auditor is enabled or not.
virtual void | beforeInitialize (INamedInterface *)=0
virtual void | afterInitialize (INamedInterface *)=0
virtual void | beforeReinitialize (INamedInterface *)=0
virtual void | afterReinitialize (INamedInterface *)=0
virtual void | beforeExecute (INamedInterface *)=0
virtual void | afterExecute (INamedInterface *, const StatusCode &)=0
virtual void | beforeBeginRun (INamedInterface *)=0
virtual void | afterBeginRun (INamedInterface *)=0
virtual void | beforeEndRun (INamedInterface *)=0
virtual void | afterEndRun (INamedInterface *)=0
virtual void | beforeFinalize (INamedInterface *)=0
virtual void | afterFinalize (INamedInterface *)=0
virtual StatusCode | sysInitialize ()=0
| Used by AuditorSvc.
virtual StatusCode | sysFinalize ()=0
| Used by AuditorSvc.
## Static Public Member Functions
static const InterfaceID & | interfaceID ()
| Retrieve interface ID.

## Member Typedef Documentation

typedef std::string IAuditor::CustomEventType

Type used to allow users to specify a custom event to be audit.

Examples of custom events are callbacks (see patch #1725).

Definition at line 43 of file IAuditor.h.

typedef const CustomEventType& IAuditor::CustomEventTypeRef

Used in function calls for optimization purposes.

Definition at line 45 of file IAuditor.h.

## Member Enumeration Documentation

enum IAuditor::StandardEventType

Defines the standard (= used by the framework) auditable event types.

Enumerator:

  Initialize |
  ReInitialize |
  Execute |
  BeginRun |
  EndRun |
  Finalize |
  Start |
  Stop |
  ReStart |

Definition at line 28 of file IAuditor.h.

    00028                          {
    00029     Initialize,
    00030     ReInitialize,
    00031     Execute,
    00032     BeginRun,
    00033     EndRun,
    00034     Finalize,
    00035     Start,
    00036     Stop,
    00037     ReStart
    00038   };

## Member Function Documentation

static const InterfaceID& IAuditor::interfaceID | ( |  | ) | `[inline, static]`

Retrieve interface ID.

Reimplemented from INamedInterface.

Reimplemented in IAuditorSvc.

Definition at line 25 of file IAuditor.h.

    00025 { return IID_IAuditor; }

virtual void IAuditor::before | ( | StandardEventType | ,
|  | INamedInterface * |  |
| ) |  |  | `[pure virtual]`

Audit the start of a standard "event".

Implemented in TimingAuditor, NameAuditor, Auditor, and AuditorSvc.

virtual void IAuditor::before | ( | StandardEventType | ,
|  | const std::string & |  |
| ) |  |  | `[pure virtual]`

Audit the start of a standard "event" for callers that do not implement INamedInterface.

Implemented in NameAuditor, Auditor, and AuditorSvc.

virtual void IAuditor::before | ( | CustomEventTypeRef | ,
|  | INamedInterface * |  |
| ) |  |  | `[pure virtual]`

Audit the start of a custom "event".

Implemented in NameAuditor, Auditor, and AuditorSvc.

virtual void IAuditor::before | ( | CustomEventTypeRef | ,
|  | const std::string & |  |
| ) |  |  | `[pure virtual]`

Audit the start of a custom "event" for callers that do not implement INamedInterface.

Implemented in TimingAuditor, ChronoAuditor, MemoryAuditor, MemStatAuditor, NameAuditor, Auditor, and AuditorSvc.

virtual void IAuditor::after | ( | StandardEventType | ,
|  | INamedInterface * | ,
|  | const StatusCode & | sc = `StatusCode(StatusCode::SUCCESS, true)` |
| ) |  |  | `[pure virtual]`

Audit the end of a standard "event".

Implemented in TimingAuditor, NameAuditor, Auditor, and AuditorSvc.

virtual void IAuditor::after | ( | StandardEventType | ,
|  | const std::string & | ,
|  | const StatusCode & | sc = `StatusCode(StatusCode::SUCCESS, true)` |
| ) |  |  | `[pure virtual]`

Audit the end of a standard "event" for callers that do not implement INamedInterface.

Implemented in NameAuditor, Auditor, and AuditorSvc.

virtual void IAuditor::after | ( | CustomEventTypeRef | ,
|  | INamedInterface * | ,
|  | const StatusCode & | sc = `StatusCode(StatusCode::SUCCESS, true)` |
| ) |  |  | `[pure virtual]`

Audit the end of a custom "event".

Implemented in NameAuditor, Auditor, and AuditorSvc.

virtual void IAuditor::after | ( | CustomEventTypeRef | ,
|  | const std::string & | ,
|  | const StatusCode & | sc = `StatusCode(StatusCode::SUCCESS, true)` |
| ) |  |  | `[pure virtual]`

Audit the end of a custom "event" for callers that do not implement INamedInterface.

Implemented in TimingAuditor, ChronoAuditor, MemoryAuditor, MemStatAuditor, NameAuditor, Auditor, and AuditorSvc.

virtual bool IAuditor::isEnabled | ( |  | ) | const`[pure virtual]`

Tell if the auditor is enabled or not.

Implemented in Auditor, and AuditorSvc.

virtual void IAuditor::beforeInitialize | ( | INamedInterface * |  | ) | `[pure virtual]`

Deprecated:
  use before

Implemented in AlgContextAuditor, ChronoAuditor, MemoryAuditor, MemStatAuditor, Auditor, and AuditorSvc.

virtual void IAuditor::afterInitialize | ( | INamedInterface * |  | ) | `[pure virtual]`

Deprecated:
  use after

Implemented in AlgContextAuditor, ChronoAuditor, MemoryAuditor, MemStatAuditor, Auditor, and AuditorSvc.

virtual void IAuditor::beforeReinitialize | ( | INamedInterface * |  | ) | `[pure virtual]`

Deprecated:
  use before

Implemented in ChronoAuditor, MemoryAuditor, MemStatAuditor, Auditor, and AuditorSvc.

virtual void IAuditor::afterReinitialize | ( | INamedInterface * |  | ) | `[pure virtual]`

Deprecated:
  use after

Implemented in ChronoAuditor, MemoryAuditor, MemStatAuditor, Auditor, and AuditorSvc.

virtual void IAuditor::beforeExecute | ( | INamedInterface * |  | ) | `[pure virtual]`

Deprecated:
  use before

Implemented in AlgContextAuditor, AlgErrorAuditor, ChronoAuditor, MemoryAuditor, MemStatAuditor, Auditor, and AuditorSvc.

virtual void IAuditor::afterExecute | ( | INamedInterface * | ,
|  | const StatusCode & |  |
| ) |  |  | `[pure virtual]`

Deprecated:
  use after

Implemented in AlgContextAuditor, AlgErrorAuditor, ChronoAuditor, MemoryAuditor, MemStatAuditor, Auditor, and AuditorSvc.

virtual void IAuditor::beforeBeginRun | ( | INamedInterface * |  | ) | `[pure virtual]`

Deprecated:
  use before

Implemented in ChronoAuditor, MemoryAuditor, MemStatAuditor, Auditor, and AuditorSvc.

virtual void IAuditor::afterBeginRun | ( | INamedInterface * |  | ) | `[pure virtual]`

Deprecated:
  use after

Implemented in ChronoAuditor, MemoryAuditor, MemStatAuditor, Auditor, and AuditorSvc.

virtual void IAuditor::beforeEndRun | ( | INamedInterface * |  | ) | `[pure virtual]`

Deprecated:
  use before

Implemented in ChronoAuditor, MemoryAuditor, MemStatAuditor, Auditor, and AuditorSvc.

virtual void IAuditor::afterEndRun | ( | INamedInterface * |  | ) | `[pure virtual]`

Deprecated:
  use after

Implemented in ChronoAuditor, MemoryAuditor, MemStatAuditor, Auditor, and AuditorSvc.

virtual void IAuditor::beforeFinalize | ( | INamedInterface * |  | ) | `[pure virtual]`

Deprecated:
  use before

Implemented in AlgContextAuditor, ChronoAuditor, MemoryAuditor, MemStatAuditor, Auditor, and AuditorSvc.

virtual void IAuditor::afterFinalize | ( | INamedInterface * |  | ) | `[pure virtual]`

Deprecated:
  use after

Implemented in AlgContextAuditor, ChronoAuditor, MemoryAuditor, MemStatAuditor, Auditor, and AuditorSvc.

virtual StatusCode IAuditor::sysInitialize | ( |  | ) | `[pure virtual]`

Used by AuditorSvc.

Implemented in Auditor, and AuditorSvc.

virtual StatusCode IAuditor::sysFinalize | ( |  | ) | `[pure virtual]`

Used by AuditorSvc.

Implemented in MemoryAuditor, MemStatAuditor, Auditor, and AuditorSvc.

The documentation for this class was generated from the following file:

- /afs/cern.ch/sw/Gaudi/releases/GAUDI/GAUDI_v20r4/GaudiKernel/GaudiKernel/IAuditor.h